// Generated from container.json. Do not edit!
#ifndef NRI_CONTAINER_SCHEMA_H
#define NRI_CONTAINER_SCHEMA_H

#include <sys/types.h>
#include <stdint.h>
#include "json_common.h"
#include "defs.h"
#include "nri_mount.h"
#include "nri_hooks.h"
#include "nri_hook.h"
#include "nri_linux_container.h"
#include "nri_linux_namespace.h"
#include "nri_linux_device.h"
#include "nri_linux_resources.h"
#include "nri_linux_memory.h"
#include "nri_linux_cpu.h"
#include "nri_hugepage_limit.h"
#include "nri_linux_device_cgroup.h"
#include "nri_posix_rlimit.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
    char *id;

    char *pod_sandbox_id;

    char *name;

    int32_t state;

    json_map_string_string *labels;

    json_map_string_string *annotations;

    char **args;
    size_t args_len;

    char **env;
    size_t env_len;

    nri_mount **mounts;
    size_t mounts_len;

    nri_hooks *hooks;

    nri_linux_container *linux;

    uint32_t pid;

    nri_posix_rlimit **rlimits;
    size_t rlimits_len;

    yajl_val _residual;
}
nri_container;

void free_nri_container (nri_container *ptr);

nri_container *make_nri_container (yajl_val tree, const struct parser_context *ctx, parser_error *err);

yajl_gen_status gen_nri_container (yajl_gen g, const nri_container *ptr, const struct parser_context *ctx, parser_error *err);

nri_container *nri_container_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err);

nri_container *nri_container_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err);

nri_container *nri_container_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err);

char *nri_container_generate_json(const nri_container *ptr, const struct parser_context *ctx, parser_error *err);

#ifdef __cplusplus
}
#endif

#endif

